/*-------------------------------------------------------------------------------------------------------------------*/
/**
 *    \file       DigitalSmooth.h
 *    \author     Baciu Vlad-Eusebiu
 *    \brief      Empty template to be used for all .h files. This file provides an example for the case in which a
 *                detailed description is not needed.
 */
/*-------------------------------------------------------------------------------------------------------------------*/

#ifndef SMOOTH_FILTER_H
#define SMOOTH_FILTER_H

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                                     Inclusions                                                    */
/*-------------------------------------------------------------------------------------------------------------------*/
#include "Std_Types.h"
/*-------------------------------------------------------------------------------------------------------------------*/
/*                                            Definition Of Global Macros                                            */
/*-------------------------------------------------------------------------------------------------------------------*/
#define DIGITALSMOOTH_LPF_COEFFICIENT           (7U)
#define DIGITALSMOOTH_LPF_SIZE                  (10U)
/*-------------------------------------------------------------------------------------------------------------------*/
/*                                          Definition Of Global Data Types                                          */
/*-------------------------------------------------------------------------------------------------------------------*/
typedef struct
{
   uint16 aul_DataArray[DIGITALSMOOTH_LPF_SIZE];
   uint8 auc_IndexArray[DIGITALSMOOTH_LPF_SIZE];
   uint8 uc_Position;
   uint8 uc_Count;
} DigitalSmooth_MedianFilter;
/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Variables                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Constants                                            */
/*-------------------------------------------------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------------------------*/
/*                                             Export Of Global Functions                                            */
/*-------------------------------------------------------------------------------------------------------------------*/
extern uint16 DigialSmooth_LPF(uint16 RawData, uint16 SensorHistory);
extern uint16 DigitalSmooth_Filter(DigitalSmooth_MedianFilter *Filter, uint16 Value);

/*-------------------------------------------------------------------------------------------------------------------*/
#endif /* SMOOTH_FILTER_H */
